require "import"

data=service.getGlobalData()
if data.time then
  --service.asyncSpeak("count down dismissed")
  --print("%sMinutes left",data.m,(os.time()-data.now)),(data.r-data.p))
  if data.time.enabled==false then
    data.r=os.time()
  end
  item={
    string.format(
    "%dminutes left",
    (data.m-((os.time()-data.now)-(data.r-data.p))//60)
    ),
    "pause",
    "stop",
    "go back"
  }

  if data.time.enabled==false then
    item[2]="resume"
  end

  dlg=LuaDialog(){
    items=item,
    onItemClick=function(l,v)
      switch(v.text)
       case "pause"
        pause()
       case "resume"
        resume()
       case "stop"
        stop()
      end
      dlg.dismiss()
    end
  }.show()
 else
  now=os.time()
  m=0
  data.now=now
  data.l=0
  time=Ticker()
  time.onTick=function()
    if data.m==nil then
      return
    end
    local t=m-(os.time()-now-(data.r-data.p))//60
    if t~=last then
      last=t
     else
      return
    end

    if t<=0 then
      stop()
     elseif t<5 then
      --print(0,t)
      service.playSoundTick()
      service.asyncSpeak(string.format("%dminutes left",t))
     elseif t%5==0 then
      --print(0,t)
      service.playSoundTick()
      service.asyncSpeak(string.format("%dminutes left",t))
    end
  end
  time.Interval=1000
  times={
    5,
    10,
    15,
20,
25,
    30,
    35,
    40,
    45,
    50,
    55,
    60,
    120,
    180,
    240,
    300,
    360,
    420,
    480,
    540,
    600,
    660,
    720,
    780,
    840,
    900,
    960,
    1020,
    1080,
    1140,
    1200,
    1260,
    1320,
    1380,
    1440
  }
  dlg=LuaDialog(){
    items={
      "5 minutes",
      "10 minutes",
      "15 minutes",
      "20 minutes",
      "25 minutes",
      "30 minutes",
      "35 minutes",
      "40 minutes",
      "45 minutes",
      "50 minutes",
      "55 minutes",
      "1 hour",
      "2 hours",
      "3 hours",
      "4 hours",
      "5 hours",
      "6 hours",
      "7 hours",
      "8 hours",
      "9 hours",
      "10 hours",
      "11 hours",
      "12 hours",
      "13 hours",
      "14 hours",
      "15 hours",
      "16 hours",
      "17 hours",
      "18 hours",
      "19 hours",
      "20 hours",
      "21 hours",
      "22 hours",
      "23 hours",
      "1 day",
          },
    onItemClick=function(l,v,p,i)
      dlg.dismiss()
      data.time=time
      data.p=0
      data.r=0
      m=times[i]
      data.m=m
      last=m
      
      time.start()
      --service.asyncSpeak(string.format("count down will be ended in%dminutes",m))
      service.asyncSpeak("the count down starts now")
    end
  }.show()
end

function stop()
  data.time.stop()
  data.time=nil
  data.p=nil
  data.r=nil
  data.m=nil
  service.playSoundClock()
  --service.asyncSpeak("count down has completed")
  service.asyncSpeak("countdown has completed")
end

function pause()
  data.time.enabled=false
  data.p=os.time()
  service.asyncSpeak("count down paused")
end

function resume()
  data.time.enabled=true
  data.r=os.time()
  service.asyncSpeak("count down resumed")
end